{{page-title @model.campaignAnswer.name " | " (capitalize (t "edit"))}}

{{#if (or this.fastboot.isFastBoot (not @model))}}
  <LoadingContainer />
{{else}}
  <Manage::EditManager as |editManager|>
    <div class="d-flex min-h-100">
      <Manage::SideBar class="order-last flex-shrink-1">
        <Manage::ModelInfo
          @isDisabled={{this.isDisabled}}
          @editablePanel={{editManager.editableField}}
          @model={{@model.campaignAnswer}}
          @onSave={{this.save}}
          @onCancel={{editManager.cancel}}
          @onEdit={{editManager.edit}}
        />
      </Manage::SideBar>

      <Manage::Container @title={{capitalize (t "survey answer")}} @breadcrumbs={{this.breadcrumbs}}>
        <:content>
          {{#if @model.map}}
            <Manage::Row @name="status" class="campaign-status">
              <div class="alert alert-light" role="alert">
                <Manage::CampaignStatus @value={{@model.campaignAnswer}} @map={{@model.map}} />
              </div>
            </Manage::Row>
          {{/if}}

          <Manage::Row @name="article">
            <Manage::Article
              @title={{t "name and description"}}
              @editablePanel={{editManager.editableField}}
              @isDisabled={{this.isDisabled}}
              @value={{@model.campaignAnswer.contentBlocks}}
              @onSave={{this.saveArticle}}
              @onCancel={{editManager.cancel}}
              @onEdit={{editManager.edit}}
            />
          </Manage::Row>

          <Manage::Row @name="icons">
            <Manage::Icons
              @title={{t "icons"}}
              @isDisabled={{this.isDisabled}}
              @value={{@model.campaignAnswer.icons}}
              @iconSets={{@model.iconSets}}
              @editablePanel={{editManager.editableField}}
              @onSave={{fn this.saveField "icons"}}
              @onCancel={{editManager.cancel}}
              @onEdit={{editManager.edit}}
            />
          </Manage::Row>

          <Manage::Row @name="location">
            <div class="location-presenter">
              <Manage::Geometry
                @isDisabled={{this.isDisabled}}
                @extent={{this.extent}}
                @baseMaps={{@model.baseMaps}}
                @icon={{@model.campaignAnswer.firstIcon}}
                @value={{@model.campaignAnswer.position}}
                @editablePanel={{editManager.editableField}}
                @disabled={{this.disabled}}
                @onSave={{fn this.saveField "position"}}
                @onCancel={{editManager.cancel}}
                @onEdit={{editManager.edit}}
              />
            </div>
          </Manage::Row>

          <Manage::Row @name="picture-list">
            <Manage::PhotoGallery
              @isDisabled={{this.isDisabled}}
              @title={{t "photos"}}
              @editablePanel={{editManager.editableField}}
              @value={{@model.campaignAnswer.pictures}}
              @onSave={{this.updatePictures}}
              @onCancel={{editManager.cancel}}
              @onEdit={{editManager.edit}}
              @model="CampaignAnswer"
              @modelId={{@model.campaignAnswer.id}}
            />
          </Manage::Row>

          <Manage::Row @name="sound-list">
            <Manage::SoundList
              @title={{t "sounds"}}
              @campaignAnswer={{@model.campaignAnswer}}
              @editablePanel={{editManager.editableField}}
              @value={{@model.campaignAnswer.sounds}}
              @onSave={{this.updateSounds}}
              @onCancel={{editManager.cancel}}
              @onEdit={{editManager.edit}}
              @isDisabled={{this.isDisabled}}
            />
          </Manage::Row>

          <Manage::Row @name="extra-questions">
            <Manage::OtherAnswers
              @title="general questions"
              @editablePanel={{editManager.editableField}}
              @questions={{@model.campaign.questions}}
              @isDisabled={{this.isDisabled}}
              @value={{@model.campaignAnswer.attributes.other}}
              @onSave={{fn this.saveField "attributes.other"}}
              @onCancel={{editManager.cancel}}
              @onEdit={{editManager.edit}}
            />
          </Manage::Row>

          <Manage::Row @name="contributor">
            <Manage::AnswerList
              @title={{t "contributor"}}
              @editablePanel={{editManager.editableField}}
              @questions={{@model.campaign.contributorQuestions}}
              @isDisabled={{this.isDisabled}}
              @value={{@model.campaignAnswer.contributor}}
              @onSave={{fn this.saveField "contributor"}}
              @onCancel={{editManager.cancel}}
              @onEdit={{editManager.edit}}
            />
          </Manage::Row>

          {{#each this.attributeSections as |attribute|}}
            <Manage::Row @name={{attribute.name}}>
              <Manage::AnswerList
                @title={{attribute.name}}
                @editablePanel={{editManager.editableField}}
                @questions={{attribute.list}}
                @isDisabled={{this.isDisabled}}
                @value={{attribute.value}}
                @onSave={{fn this.saveAttribute attribute.name}}
                @onCancel={{editManager.cancel}}
                @onEdit={{editManager.edit}}
              />
            </Manage::Row>
          {{/each}}

          {{#if @model.campaignAnswer.canReview}}
            <Manage::CampaignAnswer::Review class="mb-5" @value={{@model.campaignAnswer}} />
          {{/if}}
        </:content>
      </Manage::Container>
    </div>
  </Manage::EditManager>
{{/if}}